<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>Extending the Framework Core With Extensions</h1>

		<p>CarbonPHP has the feature to allow users to extend the framework core without hacking the core classes.
		When CarbonPHP runs it follows a specific flow.  There are some times when you might want an action to occur
		at a stage during the execution.  If you want to run a method right before the controller gets loaded you
		can declare an extension to do this.</p>
	</div>

	<div class="content">
		<h1>Enabling Extensions</h1>

		<p>The extensions feature can be enabled or disabled by changing the item in the
		<b>application/config/config.php</b> configuration file.</p>

		<div class="example">
			$config['enable_extensions'] = true;
		</div>
	</div>

	<div class="content">
		<h1>Declaring an Extension</h1>

		<p>Extensions are declared in the <b>application/config/extensions.php</b> configuration file.  Each extension
		follows the following prototype.</p>

		<div class="example">
			$extension['pre_controller'] = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'class' => 'Ext_class',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'method' => 'ExtMethod',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'filename' => 'Ext_class.php',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'filepath' => 'extensions',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'params' => array('small', 'medium', 'large')<br />
			);<br />
		</div>

		<p><i>Note</i>: the array index correlates to the name of the extension you wish to use.  In the above example
		the extension point is <b>pre_controller</b>.  The list of available extension points are outlined below.</p>

		<ul>
			<li><b>class</b> - the name of the class you wish to invoke for the extension.  You can use a standard
			procedural function by leaving this index blank.</li>
			<li><b>method</b> - the name of the method or function you wish to call.</li>
			<li><b>filename</b> - the name of the file containing the class method or function.</li>
			<li><b>filepath</b> - the name of the directory containing the file.  The file must be located inside
			the <b>application/</b> directory.  So the filepath is relative to this directory.</li>
			<li><b>params</b> - Any parameters you wish to pass to your file.  This is optional.</li>
		</ul>
	</div>

	<div class="content">
		<h1>Calling an Extension Multiple Times</h1>

		<p>If you wish to use the same extension point with more than once, you simply just create a multi-dimensional
		array.</p>

		<div class="example">
			$extension['pre_controller']<b>[]</b> = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'class' => 'Ext_class',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'method' => 'ExtMethod',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'filename' => 'Ext_class.php',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'filepath' => 'extensions',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'params' => array('small', 'medium', 'large')<br />
			);<br />
			<br />
			$extension['pre_controller']<b>[]</b> = array(<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'class' => 'Ext_otherclass',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'method' => 'ExtOtherMethod',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'filename' => 'Ext_otherclass.php',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'filepath' => 'extensions',<br />
			&nbsp;&nbsp;&nbsp;&nbsp;'params' => array('blue', 'red', 'green')<br />
			);<br />
		</div>

		<p><i>Note</i>: the order in which you declare the array is the order in which they will get executed.</p>
	</div>

	<div class="content">
		<h1>Extension Points</h1>

		<p>The following is a list of extension points that you can use.</p>

		<ul>
			<li><b>pre_system</b> - Called during the early stage of system execution.  Only the benchmark and 
			extensions classes have been loaded.  No routing or other processes have occured.</li>
			<li><b>pre_controller</b> - Called immediately prior to any controllers being called.  All core classes,
			routing, and security checks have occured.</li>
			<li><b>post_controller_constructor</b> - Called immidiately after the controllers constructor is called,
			but before any class method is called.</li>
			<li><b>post_controller</b> - Called immediately after the controller has finished executing.</li>
			<li><b>display_override</b> - Overrides the <b>_display()</b> method.  You can get the final data by
			calling the <b>$this->output->get_output()</b> method.</li>
			<li><b>cache_override</b> - Overrides the <b>_display_cache()</b> method in the output class.  This
			allows you to use your own caching solution.</li>
			<li><b>scaffolding_override</b> - Allows a scaffolding requests to trigger your own class instead.</li>
			<li><b>post_system</b> - Called after the final rendered page has been sent to the browser.</li>
		</ul>
	</div>
</body>

</html>
